#include <iostream>
#include <string.h>
#include <math.h>
using namespace std;
//anavolimilovana

int main()
{
    string niska;
    cin>>niska;
    int v=niska.size();

    char arr[niska.length() + 1];
	strcpy(arr, niska.c_str());

    char pom = niska[0];

    for(int i = 1; i < v; i++)
    {
        pom = pom ^ niska[i];
    }
    int br=0;
    cout<<v/2;
    if(niska[v/2]==pom)
    {
        for(int i=0;i<v/2;i++)
        {
            if(niska[i]!=niska[v-i-1]) br++;

        }
    }
    else
    {
        for(int i=0;i<v/2;i++)
        {
            if(niska[i]!=niska[v-i]) break;
            br++;

        }
    }


    if(br==0) br++;
    cout<<br;



}